/*______________________________________________________________________
 | _|_																	|
 |    WAVE2SND Project: Balthazar				Started:	12/14/92	|
 | 									 	  Last Modified:	12/21/92	|
 | 									 	 		Release:	12/27/92	|
 | 																		|
 | 	Craig Marciniak														|
 | 	151 83rd Ave, NE #305												|
 | 	Fridley, Mn 55432													|
 | 	612-780-5603														|
 | 						 												|
 | Copyright  1992 by Craig A. Marciniak          All rights reserved. |
 _______________________________________________________________________*/

 #include		"balthazar.h"
 
 InfoRec 		gInfoBlock;
 short			gRefNum;
 short			gVolSet;

/*_____________________________________________________ The Main Thing _*/

void main ()
{
	ToolBoxInit();

	DoMainDialog();
	
	BlowPopStand();
}

/*_________________________________________________ Initialize Toolbox _*/

void ToolBoxInit()
{
	long		response;
	
	InitGraf(&thePort);
	InitFonts();
	FlushEvents(everyEvent,0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(NULL);
	InitCursor();
	
	if(Gestalt(gestaltVersion, &response))
		FatalError((Ptr)ksysFailed);
	if(!Gestalt(gestaltSystemVersion, &response))
		if(response>>8< 7)
			FatalError((Ptr)ksysFailed);
	
	GetSoundVol(&gVolSet);
	SetSoundVol(kmaxVolume);		
	gRefNum = CurResFile();
}

/*_______________________________________________________ Open or Quit _*/

void DoMainDialog()
{
	DialogPtr 		myDialog;
	GrafPtr			tempPort;
	int				theHit;	
	
	GetPort(&tempPort);	
	myDialog = GetNewDialog(128,NIL,(WindowPtr)-1L);
	SetPort( myDialog);

	do{
		ModalDialog(nil,&theHit);
		switch(theHit)
		{
			case 2:
				DoOpen();
				break;
			default :
				break;
		}
	}while(theHit != 1);
	
	DisposDialog(myDialog);
	SetPort(tempPort);
}

/*____________________________________________________ Get a .WAV File _*/

void DoOpen(void)
{
	StandardFileReply	sfReply;
	FInfo				fileInfo;

	StandardGetFile(NIL,-1,NIL,&sfReply);
	
	if(sfReply.sfGood) ProcessAFile(&sfReply.sfFile);
}

/*__________________________________________________ Process .WAV File _*/

void ProcessAFile(FSSpec *fileSpec)
{
	StandardFileReply	myReply;
	PCMWaveHnd			WAVERsrc;
	CraigSNDHnd			snd_Hand;
	DialogPtr 			myDialog;
	GrafPtr				tempPort;
	short				fRef,tempResRef,x;
	long				fSize;
	int					theHit;
	char				test;
dildo		s;

	GetPort(&tempPort);	
	
	if(!FSpOpenDF(fileSpec,fsRdWrPerm,&fRef))
	{
		GetEOF(fRef,&fSize);
		if(!(WAVERsrc = (PCMWaveHnd)NewHandle(fSize))) 
		{
			FSClose(fRef); return;
		}
		
		HLock(WAVERsrc);
		if(FSRead(fRef,&fSize,&(**WAVERsrc)))
		{
			FSClose(fRef); return;
		}
		
		if((**WAVERsrc).ckid =='RIFF')
		{
			(**WAVERsrc).cksize = longswap((**WAVERsrc).cksize);
			
			if((**WAVERsrc).fccType =='WAVE')
			{
				(**WAVERsrc).dwDataOffset = longswap((**WAVERsrc).dwDataOffset);
				
				if((**WAVERsrc).fmtType,'fmt ')
				{
					(**WAVERsrc).wFormatTag      = shrtswap((**WAVERsrc).wFormatTag);
					(**WAVERsrc).nCannels        = shrtswap((**WAVERsrc).nCannels);
					(**WAVERsrc).nSamplesPerSec  = longswap((**WAVERsrc).nSamplesPerSec);
					NumToString((**WAVERsrc).nSamplesPerSec,gInfoBlock.smpls);
					(**WAVERsrc).nSamplesPerSec  = (**WAVERsrc).nSamplesPerSec << 16;
					(**WAVERsrc).nAvgBytesPerSec = longswap((**WAVERsrc).nAvgBytesPerSec);
					(**WAVERsrc).nBlockAlign     = shrtswap((**WAVERsrc).nBlockAlign);
					(**WAVERsrc).wBitsPerSample  = shrtswap((**WAVERsrc).wBitsPerSample);
					(**WAVERsrc).dataSize        = longswap((**WAVERsrc).dataSize);
					
					PStrCpy(fileSpec->name, gInfoBlock.name);
					NumToString((**WAVERsrc).wBitsPerSample, gInfoBlock.dataBits);
					
					if((**WAVERsrc).wFormatTag != 1)
					{
						StopError((Ptr)"\pNot a PCM Format 1 type WAVE file.");
						return;
					}
				}
				else
				{
					StopError((Ptr)"\pNo format chunk found.");
					HUnlock(WAVERsrc);
					DisposeHandle(WAVERsrc);
					return;
				}	
			}
			else
			{
				StopError((Ptr)"\pSorry, not a WAVE type file.");
				HUnlock(WAVERsrc);
				DisposeHandle(WAVERsrc);
				return;
			}
		}
		else
		{
			StopError((Ptr)"\pNo RIFF chunk found. Probally not a Wave File.");
			HUnlock(WAVERsrc);
			DisposeHandle(WAVERsrc);
			return;
		}
		HUnlock(WAVERsrc);
		FSClose(fRef);
	}
	
	if(snd_Hand = (CraigSNDHnd)NewHandleClear(sizeof(CraigSNDRec) + (**WAVERsrc).dataSize) )
	{
		HLock(snd_Hand);
		(**snd_Hand).formatType		= 0x0001;
		(**snd_Hand).numberSyns		= 0x0001;
		(**snd_Hand).idFirstSynth	= 0x0005;
		
		if((**WAVERsrc).nCannels == 2)
		{
			PStrCpy(kStereoStr, gInfoBlock.stereo);
			(**snd_Hand).INIToptions	= 0x00000C0;
		}
		else
		{
			PStrCpy(kMonoStr, gInfoBlock.stereo);
			(**snd_Hand).INIToptions	= 0x0000080;
		}

		(**snd_Hand).numCommands	= 0x0001;
		(**snd_Hand).command1		= 0x8051;
		(**snd_Hand).param2			= 0x00000014;

		HLock(WAVERsrc);
			(**snd_Hand).s.length		 = (**WAVERsrc).dataSize ;
			(**snd_Hand).s.sampleRate	 = (**WAVERsrc).nSamplesPerSec;

		BlockMove((Ptr)(long)((**WAVERsrc).theData), (Ptr)(**snd_Hand).s.sampleArea , (**WAVERsrc).dataSize);
			 
		HUnlock(WAVERsrc);
		DisposeHandle(WAVERsrc);
		
		myDialog = GetNewDialog(129,NIL,(WindowPtr)-1L);
		SetPort( myDialog);
	
		do{
			ModalDialog(BalthaFilter,&theHit);
			switch(theHit)
			{
				case 2:
					StandardPutFile("\pSave as:",fileSpec->name,&myReply);
					if(myReply.sfGood) 
					{
						FSpCreateResFile(&myReply.sfFile,'BTZR','sfil',myReply.sfScript);
						
						if((tempResRef = FSpOpenResFile(&myReply.sfFile,fsRdWrPerm)) > 0)
						{
							UseResFile(tempResRef);
							
							AddResource(snd_Hand,'snd ',UniqueID('snd '),myReply.sfFile.name);
							if(ResError()) FatalError((Ptr)"\pAddResource failed, oh well...");
							WriteResource(snd_Hand);
							ReleaseResource(snd_Hand);

							UseResFile(gRefNum);
							DisposDialog(myDialog);
							SetPort(tempPort);
							return;
						}
						else
							FatalError((Ptr)"\pSorry there was a File Manager related error.");
					}
					break;
				case 3:
					SndPlay(NIL,(Handle)snd_Hand, FALSE);
					break;
				default :
					break;
			}
		}while(theHit != 1);
		
		HUnlock(snd_Hand);
		DisposeHandle(snd_Hand);
		DisposDialog(myDialog);
		SetPort(tempPort);
	}
	else
		StopError((Ptr)"\pNot enough memory, try increasing the RAM partion size.");
}

/*__________________________________________________________ Draw Info _*/

pascal Boolean BalthaFilter(DialogPtr dlog,EventRecord *event,short *itemHit)
{	

	if(event->what == updateEvt) 
	{
		TextFont(monaco); TextSize(9);
		MoveTo(40,15);
		DrawString("\p    file name: "); DrawString(gInfoBlock.name);
		MoveTo(40,27);
		DrawString("\p  sample rate: "); DrawString(gInfoBlock.smpls);
		MoveTo(40,39);
		DrawString("\p    data bits: "); DrawString(gInfoBlock.dataBits);
		MoveTo(40,51);
		DrawString("\p     channels: "); DrawString(gInfoBlock.stereo);
    }
	return false;
}

/*____________________________________________ Shut The Door Behind Me _*/

void BlowPopStand()
{
	SetSoundVol(gVolSet);
	ExitToShell();
}

/*______________________________________________________________________*/